## librdkafka 0.8.3

=== Makefile ===
LIBNAME=librdkafka
LIBVER=1

DESTDIR?=/usr/local

SRCS=	rdkafka.c rdkafka_broker.c rdkafka_msg.c rdkafka_topic.c \
	rdkafka_defaultconf.c rdkafka_timer.c rdkafka_offset.c
SRCS+=  rdcrc32.c rdgz.c rdaddr.c rdrand.c rdthread.c rdqueue.c rdlog.c
SRCS+=	snappy.c
HDRS=	rdkafka.h

OBJS=	$(SRCS:.c=.o)
DEPS=	${OBJS:%.o=%.d}

CFLAGS+=-O2 -Wall -Werror -Wfloat-equal -Wpointer-arith -I.
CFLAGS+=-g

# Clang warnings to ignore
ifeq ($(CC),clang)
	CFLAGS+=-Wno-gnu-designator
endif

# Enable iovecs in snappy
CFLAGS+=-DSG

# Profiling
#CFLAGS+=-O0
#CFLAGS += -pg
#LDFLAGS += -pg

LDFLAGS+= -g
UNAME_S = $(shell uname -s)
ifneq ($(findstring CYGWIN,$(UNAME_S)),CYGWIN)
	LDFLAGS+=-fPIC
	CFLAGS+=-fPIC
endif

.PHONY:

all: libs check

libs: $(LIBNAME).so.$(LIBVER) $(LIBNAME).a CONFIGURATION.md

%.o: %.c
	$(CC) -MD -MP $(CFLAGS) -c $<

librdkafka.lds: rdkafka.h
	@echo "\033[33mGenerating linker script $@\033[0m"
	@./lds-gen.pl > $@

$(LIBNAME).so.$(LIBVER): $(OBJS) librdkafka.lds
	@echo "\033[33mCreating shared library $@\033[0m"
	@(if [ $(UNAME_S) = "Darwin" ]; then \
		$(CC) $(LDFLAGS) \
			$(OBJS) -dynamiclib -o $@ -lpthread -lz -lc ; \
	else \
		$(CC) $(LDFLAGS) \
			-shared -Wl,-soname,$@ \
			-Wl,--version-script=librdkafka.lds \
			$(OBJS) -o $@ -lpthread -lrt -lz -lc ; \
	fi)

$(LIBNAME).a:	$(OBJS)
	@echo "\033[33mCreating static library $@\033[0m"
	$(AR) rcs $@ $(OBJS)


CONFIGURATION.md: rdkafka.h examples
	@echo "\033[33mUpdating $@\033[0m"
	@(examples/rdkafka_performance -X list > CONFIGURATION.md.tmp; \
	cmp CONFIGURATION.md CONFIGURATION.md.tmp || \
		mv CONFIGURATION.md.tmp CONFIGURATION.md; \
	rm -f CONFIGURATION.md.tmp)

examples: .PHONY
	make -C $@

install:
	@echo "\033[33mInstall to root $(DESTDIR)\033[0m"
	if [ "$(DESTDIR)" != "/usr/local" ]; then \
		DESTDIR="$(DESTDIR)/usr"; \
	else \
		DESTDIR="$(DESTDIR)" ; \
	fi ; \
	install -d $$DESTDIR/include/librdkafka $$DESTDIR/lib ; \
	install $(HDRS) $$DESTDIR/include/$(LIBNAME) ; \
	install $(LIBNAME).a $$DESTDIR/lib ; \
	install $(LIBNAME).so.$(LIBVER) $$DESTDIR/lib ; \
	(cd $$DESTDIR/lib && ln -sf $(LIBNAME).so.$(LIBVER) $(LIBNAME).so)

tests: .PHONY check
	make -C tests

check:
	@echo "\033[33mChecking integrity\033[0m"
	@(RET=true ; \
	 for f in librdkafka.so.1 librdkafka.a CONFIGURATION.md \
		examples/rdkafka_example examples/rdkafka_performance ; do \
		printf "%-30s " $$f ; \
		if [ -f "$$f" ]; then \
			echo "\033[32mOK\033[0m"; \
		else \
			echo "\033[31mMISSING\033[0m"; \
			RET=false ; \
		fi; \
	done ; \
	$$($$RET))

	@(printf "%-30s " "Symbol visibility" ; \
	((nm -D librdkafka.so.1 | grep -q rd_kafka_new) && \
	  (nm -D librdkafka.so.1 | grep -vq rd_kafka_destroy) && \
		echo "\033[32mOK\033[0m") || \
	  echo "\033[31mFAILED\033[0m")



clean:
	rm -f $(OBJS) $(DEPS) \
		$(LIBNAME)*.a $(LIBNAME)*.so $(LIBNAME)*.so.$(LIBVER) \
		librdkafka.lds
	make -C tests clean
	make -C examples clean

-include $(DEPS)

=== examples/Makefile ===
EXAMPLES ?= rdkafka_example rdkafka_performance
CC ?= cc
CXX ?= g++
CFLAGS += -g -Wall -Werror -Wfloat-equal -Wpointer-arith -O2 -I../
CXXFLAGS += $(CFLAGS)
LDFLAGS +=  ../librdkafka.a
LDFLAGS += -lpthread -lz
ifeq ($(shell uname -s), Linux)
	LDFLAGS += -lrt
endif

# Profiling
#CFLAGS += -O0 -pg
#LDFLAGS += -pg

all: $(EXAMPLES)

rdkafka_example: ../librdkafka.a rdkafka_example.c
	@(test $@ -nt $< || \
	  $(CC) $(CFLAGS) rdkafka_example.c -o $@ $(LDFLAGS))
	@echo "# $@ is ready"
	@echo "#"
	@echo "# Run producer (write messages on stdin)"
	@echo "./rdkafka_example -P -t <topic> -p <partition>"
	@echo ""
	@echo "# or consumer"
	@echo "./rdkafka_example -C -t <topic> -p <partition>"
	@echo ""
	@echo "#"
	@echo "# More usage options:"
	@echo "./rdkafka_example --help"

rdkafka_performance: ../librdkafka.a rdkafka_performance.c
	@(test $@ -nt $< || \
	  $(CC) $(CFLAGS) rdkafka_performance.c -o $@ $(LDFLAGS))
	@echo "# $@ is ready"
	@echo "#"
	@echo "# Run producer"
	@echo "./$@ -P -t <topic> -p <partition> -s <msgsize>"
	@echo ""
	@echo "# or consumer"
	@echo "./$@ -C -t <topic> -p <partition>"
	@echo ""
	@echo "#"
	@echo "# More usage options:"
	@echo "./$@ --help"


clean:
	rm -f rdkafka_example rdkafka_performance

=== tests/Makefile ===
TESTSRCS ?= $(wildcard 0*-*.c)
TESTS    ?= $(TESTSRCS:%.c=%.test)

CC ?= cc
CXX ?= g++
CFLAGS += -g -Wall -Werror -Wfloat-equal -Wpointer-arith -O2 -I../
CXXFLAGS += $(CFLAGS)
LDFLAGS +=  -L../ -lrdkafka
LDFLAGS += -lpthread -lz
ifeq ($(shell uname -s), Linux)
	LDFLAGS += -lrt
endif

# Profiling
#CFLAGS += -O0 -pg
#LDFLAGS += -pg


%.test: ../librdkafka.a test.o %.c
	$(CC) $(CFLAGS) $^ -o $@ $(LDFLAGS)

all: $(TESTS)
	for i in $^ ; do \
	 LD_LIBRARY_PATH=../ ./run-test.sh $$i || exit 1 ; \
	done

test.o: test.c
	$(CC) $(CFLAGS) -c $<


clean:
	rm -f *.test

## librdkafka 0.8.0

=== debian/changelog ===
librdkafka (0.8.0-1) unstable; urgency=low

  * Initial release. (Closes: #710271)

 -- Faidon Liambotis <paravoid@debian.org>  Mon, 04 Nov 2013 16:50:07 +0200

=== debian/control ===
Source: librdkafka
Priority: optional
Maintainer: Faidon Liambotis <paravoid@debian.org>
Build-Depends: debhelper (>= 9), zlib1g-dev
Standards-Version: 3.9.4
Section: libs
Homepage: https://github.com/edenhill/librdkafka
Vcs-Git: git://github.com/edenhill/librdkafka.git -b debian
Vcs-Browser: https://github.com/edenhill/librdkafka/tree/debian

Package: librdkafka1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: library implementing the Apache Kafka protocol
 librdkafka is a C implementation of the Apache Kafka protocol. It currently
 implements the 0.8 version of the protocol and can be used to develop both
 Producers and Consumers.
 .
 More information about Apache Kafka can be found at http://kafka.apache.org/

Package: librdkafka-dev
Section: libdevel
Architecture: any
Depends: librdkafka1 (= ${binary:Version}), ${misc:Depends}
Description: library implementing the Apache Kafka protocol (development headers)
 librdkafka is a C implementation of the Apache Kafka protocol. It currently
 implements the 0.8 version of the protocol and can be used to develop both
 Producers and Consumers.
 .
 More information about Apache Kafka can be found at http://kafka.apache.org/
 .
 This package contains the development headers.

Package: librdkafka1-dbg
Section: debug
Priority: extra
Architecture: any
Depends: librdkafka1 (= ${binary:Version}), ${misc:Depends}
Description: library implementing the Apache Kafka protocol (debugging symbols)
 librdkafka is a C implementation of the Apache Kafka protocol. It currently
 implements the 0.8 version of the protocol and can be used to develop both
 Producers and Consumers.
 .
 More information about Apache Kafka can be found at http://kafka.apache.org/
 .
 This package contains the debugging symbols.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

override_dh_strip:
	dh_strip --dbg-package=librdkafka1-dbg

# remove after 0.8.0, upstrema bug fixed in master
override_dh_auto_clean:
	dh_auto_clean
	$(MAKE) -C examples clean

.PHONY: override_dh_strip override_dh_auto_clean

## librdkafka 0.8.3

=== debian/changelog ===
librdkafka (0.8.3-1ubuntu2) trusty; urgency=medium

  * link-atomic.patch: Fix s/__atmoic/__atomic/ typo in the previous patch.

 -- Adam Conrad <adconrad@ubuntu.com>  Sun, 23 Feb 2014 18:15:37 -0700

librdkafka (0.8.3-1ubuntu1) trusty; urgency=medium

  * link-atomic.patch: Switch from __sync to __atomic to support more arches.
  * Switch back to arch:any instead of the Debian maintainer's shorter list.

 -- Adam Conrad <adconrad@ubuntu.com>  Sat, 22 Feb 2014 16:59:19 -0700

librdkafka (0.8.3-1) unstable; urgency=medium

  * New upstream release.
    - Multiple internal symbols hidden; breaks ABI without a SONAME bump, but
      these were internal and should not break any applications, packaged or
      not.
  * Update Standards-Version to 3.9.5, no changes needed.

 -- Faidon Liambotis <paravoid@debian.org>  Tue, 18 Feb 2014 02:21:43 +0200

librdkafka (0.8.1-1) unstable; urgency=medium

  * New upstream release.
    - Multiple fixes to FTBFS on various architectures. (Closes: #730506)
    - Remove dh_auto_clean override, fixed upstream.
  * Limit the set of architectures: upstream currently relies on 64-bit atomic
    operations that several Debian architectures do not support.

 -- Faidon Liambotis <paravoid@debian.org>  Thu, 05 Dec 2013 16:53:28 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,9 @@
 Source: librdkafka
 Priority: optional
-Maintainer: Faidon Liambotis <paravoid@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Faidon Liambotis <paravoid@debian.org>
 Build-Depends: debhelper (>= 9), zlib1g-dev
-Standards-Version: 3.9.4
+Standards-Version: 3.9.5
 Section: libs
 Homepage: https://github.com/edenhill/librdkafka
 Vcs-Git: git://github.com/edenhill/librdkafka.git -b debian

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

override_dh_strip:
	dh_strip --dbg-package=librdkafka1-dbg

.PHONY: override_dh_strip

=== debian/watch ===
version=3
http://github.com/edenhill/librdkafka/tags .*/(\d[\d\.]*)\.tar\.gz

## librdkafka 0.8.5

=== Makefile ===
LIBSUBDIRS=	src src-cpp

CHECK_FILES+=	CONFIGURATION.md \
		examples/rdkafka_example examples/rdkafka_performance \
		examples/rdkafka_example_cpp

.PHONY:

all: mklove-check libs CONFIGURATION.md check

include mklove/Makefile.base

libs:
	@(for d in $(LIBSUBDIRS); do $(MAKE) -C $$d || exit $?; done)

CONFIGURATION.md: src/rdkafka.h examples
	@echo "\033[33mUpdating $@\033[0m"
	@(examples/rdkafka_performance -X list > CONFIGURATION.md.tmp; \
	cmp CONFIGURATION.md CONFIGURATION.md.tmp || \
		mv CONFIGURATION.md.tmp CONFIGURATION.md; \
	rm -f CONFIGURATION.md.tmp)

check: file-check
	@(for d in $(LIBSUBDIRS); do $(MAKE) -C $$d $@ || exit $?; done)

install:
	@(for d in $(LIBSUBDIRS); do $(MAKE) -C $$d $@ || exit $?; done)

examples tests: .PHONY
	$(MAKE) -C $@

clean:
	@$(MAKE) -C tests $@
	@$(MAKE) -C examples $@
	@(for d in $(LIBSUBDIRS); do $(MAKE) -C $$d $@ ; done)

=== src-cpp/Makefile ===
PKGNAME=	librdkafka
LIBNAME=	librdkafka++
LIBVER=		1

CXXSRCS=	RdKafka.cpp ConfImpl.cpp HandleImpl.cpp \
		ConsumerImpl.cpp ProducerImpl.cpp \
		TopicImpl.cpp MessageImpl.cpp

HDRS=		rdkafkacpp.h

OBJS=		$(CXXSRCS:%.cpp=%.o)



all: lib check


include ../mklove/Makefile.base

# No linker script/symbol hiding for C++ library
WITH_LDS=n

LIBS += -lstdc++

CHECK_FILES+= $(LIBFILENAME) $(LIBNAME).a

check: file-check

install: lib-install

clean: lib-clean

ifeq ($(WITH_LDS),y)
# Enable linker script if supported by platform
LIB_LDFLAGS+= $(LDFLAG_LINKERSCRIPT)$(LIBNAME).lds
endif

$(LIBNAME).lds: $(HDRS)
	@(echo "$(MKL_YELLOW)Generating linker script $@ from $(HDRS)$(MKL_CLR_RESET)" ; \
	  cat ../src/rdkafka.h | ../lds-gen.pl > $@)

-include $(DEPS)

=== src/Makefile ===
PKGNAME=	librdkafka
LIBNAME=	librdkafka
LIBVER=		1


SRCS=		rdkafka.c rdkafka_broker.c rdkafka_msg.c rdkafka_topic.c \
		rdkafka_defaultconf.c rdkafka_timer.c rdkafka_offset.c \
		rdcrc32.c rdgz.c rdaddr.c rdrand.c rdthread.c rdqueue.c \
		rdlog.c \
		snappy.c

HDRS=		rdkafka.h

OBJS=		$(SRCS:.c=.o)


all: lib check

include ../mklove/Makefile.base

CHECK_FILES+= $(LIBFILENAME) $(LIBNAME).a

check: file-check
	@(printf "%-30s " "Symbol visibility" ; \
	(($(SYMDUMPER) $(LIBFILENAME) | grep -q rd_kafka_new) && \
	  ($(SYMDUMPER) $(LIBFILENAME) | grep -vq rd_kafka_destroy) && \
		echo "\033[32mOK\033[0m") || \
	  echo "\033[31mFAILED\033[0m")

install: lib-install

clean: lib-clean

ifeq ($(WITH_LDS),y)
# Enable linker script if supported by platform
LIB_LDFLAGS+= $(LDFLAG_LINKERSCRIPT)$(LIBNAME).lds
endif

$(LIBNAME).lds: $(HDRS)
	@(echo "$(MKL_YELLOW)Generating linker script $@ from $(HDRS)$(MKL_CLR_RESET)" ; \
	  cat $(HDRS) | ../lds-gen.pl > $@)

-include $(DEPS)

=== debian/changelog ===
librdkafka (0.8.5-2ubuntu1) vivid; urgency=medium

  * as-needed-fix.patch: Break up libs from cflags in the configure compile
    tests so we can put the libs at the end of the linker line, fixing test
    detection issues when building with -Wl,--as-needed passed to binutils.

 -- Adam Conrad <adconrad@ubuntu.com>  Wed, 11 Mar 2015 05:55:33 -0600

librdkafka (0.8.5-2) unstable; urgency=medium

  * Install rdkafka.pc in the right, multiarch location. (Closes: #766759)

 -- Faidon Liambotis <paravoid@debian.org>  Sun, 26 Oct 2014 06:47:07 +0200

librdkafka (0.8.5-1) unstable; urgency=medium

  * New upstream release.
    - Fixes kFreeBSD FTBFS.
  * Ship rdkafka.pc pkg-config in librdkafka-dev.

 -- Faidon Liambotis <paravoid@debian.org>  Fri, 24 Oct 2014 18:03:22 +0300

librdkafka (0.8.4-1) unstable; urgency=medium

  * New upstream release, including a new build system.
    - Add Build-Depends on perl, required by configure.
    - Support multiarch library paths.
    - Better detection of architecture atomic builtins, supporting more
      architectures. (Closes: #739930)
    - Various portability bugs fixed. (Closes: #730506)
    - Update debian/librdkafka1.symbols.
  * Convert to a multiarch package.
  * Switch to Architecture: any, because of renewed upstream portability.
  * Update debian/copyright to add src/ before Files: paths.
  * Update Standards-Version to 3.9.6, no changes needed.
  * Ship only the C library for now, not the new C++ library; the latter is
    still in flux in some ways and will probably be shipped in a separate
    package in a future release.

 -- Faidon Liambotis <paravoid@debian.org>  Wed, 22 Oct 2014 23:57:24 +0300

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Faidon Liambotis <paravoid@debian.org>
-Build-Depends: debhelper (>= 9), zlib1g-dev
-Standards-Version: 3.9.5
+Build-Depends: debhelper (>= 9), zlib1g-dev, perl
+Standards-Version: 3.9.6
 Section: libs
 Homepage: https://github.com/edenhill/librdkafka
 Vcs-Git: git://github.com/edenhill/librdkafka.git -b debian
@@ -11,6 +11,7 @@
 
 Package: librdkafka1
 Architecture: any
+Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: library implementing the Apache Kafka protocol
  librdkafka is a C implementation of the Apache Kafka protocol. It currently
@@ -22,6 +23,7 @@
 Package: librdkafka-dev
 Section: libdevel
 Architecture: any
+Multi-Arch: same
 Depends: librdkafka1 (= ${binary:Version}), ${misc:Depends}
 Description: library implementing the Apache Kafka protocol (development headers)
  librdkafka is a C implementation of the Apache Kafka protocol. It currently
@@ -36,6 +38,7 @@
 Section: debug
 Priority: extra
 Architecture: any
+Multi-Arch: same
 Depends: librdkafka1 (= ${binary:Version}), ${misc:Depends}
 Description: library implementing the Apache Kafka protocol (debugging symbols)
  librdkafka is a C implementation of the Apache Kafka protocol. It currently

## librdkafka 0.8.6

=== Makefile ===
--- 
+++ 
@@ -20,13 +20,14 @@
 		mv CONFIGURATION.md.tmp CONFIGURATION.md; \
 	rm -f CONFIGURATION.md.tmp)
 
+file-check: CONFIGURATION.md examples
 check: file-check
 	@(for d in $(LIBSUBDIRS); do $(MAKE) -C $$d $@ || exit $?; done)
 
 install:
 	@(for d in $(LIBSUBDIRS); do $(MAKE) -C $$d $@ || exit $?; done)
 
-examples tests: .PHONY
+examples tests: .PHONY libs
 	$(MAKE) -C $@
 
 clean:

=== examples/Makefile ===
EXAMPLES ?= rdkafka_example rdkafka_performance rdkafka_example_cpp

all: $(EXAMPLES)

include ../mklove/Makefile.base

CFLAGS += -I../src
CXXFLAGS += -I../src-cpp

# librdkafka must be compiled with -gstrict-dwarf, but rdkafka_example must not,
# due to some clang bug on OSX 10.9
CPPFLAGS := $(subst strict-dwarf,,$(CPPFLAGS))

rdkafka_example: ../src/librdkafka.a rdkafka_example.c
	$(CC) $(CPPFLAGS) $(CFLAGS) rdkafka_example.c -o $@ $(LDFLAGS) \
		../src/librdkafka.a $(LIBS)
	@echo "# $@ is ready"
	@echo "#"
	@echo "# Run producer (write messages on stdin)"
	@echo "./rdkafka_example -P -t <topic> -p <partition>"
	@echo ""
	@echo "# or consumer"
	@echo "./rdkafka_example -C -t <topic> -p <partition>"
	@echo ""
	@echo "#"
	@echo "# More usage options:"
	@echo "./rdkafka_example --help"

rdkafka_performance: ../src/librdkafka.a rdkafka_performance.c
	$(CC) $(CPPFLAGS) $(CFLAGS) rdkafka_performance.c -o $@ $(LDFLAGS) \
		../src/librdkafka.a $(LIBS)
	@echo "# $@ is ready"
	@echo "#"
	@echo "# Run producer"
	@echo "./$@ -P -t <topic> -p <partition> -s <msgsize>"
	@echo ""
	@echo "# or consumer"
	@echo "./$@ -C -t <topic> -p <partition>"
	@echo ""
	@echo "#"
	@echo "# More usage options:"
	@echo "./$@ --help"


rdkafka_example_cpp: ../src-cpp/librdkafka++.a ../src/librdkafka.a rdkafka_example.cpp
	$(CXX) $(CPPFLAGS) $(CXXFLAGS) rdkafka_example.cpp -o $@ $(LDFLAGS) \
		../src-cpp/librdkafka++.a ../src/librdkafka.a $(LIBS) -lstdc++

rdkafka_zookeeper_example: ../src/librdkafka.a rdkafka_zookeeper_example.c
	$(CC) $(CPPFLAGS) $(CFLAGS) -I/usr/include/zookeeper rdkafka_zookeeper_example.c -o $@ $(LDFLAGS) \
		../src/librdkafka.a $(LIBS) -lzookeeper_mt -ljansson
	@echo "# $@ is ready"
	@echo "#"
	@echo "# Run producer (write messages on stdin)"
	@echo "./rdkafka_zookeeper_example -P -t <topic> -p <partition>"
	@echo ""
	@echo "# or consumer"
	@echo "./rdkafka_zookeeper_example -C -t <topic> -p <partition>"
	@echo ""
	@echo "#"
	@echo "# More usage options:"
	@echo "./rdkafka_zookeeper_example --help"

clean:
	rm -f $(EXAMPLES)

=== src-cpp/Makefile ===
--- 
+++ 
@@ -20,10 +20,24 @@
 # No linker script/symbol hiding for C++ library
 WITH_LDS=n
 
+# OSX and Cygwin requires linking required libraries
+ifeq ($(_UNAME_S),Darwin)
+	FWD_LINKING_REQ=y
+endif
+ifeq ($(shell uname -o),Cygwin)
+	FWD_LINKING_REQ=y
+endif
+
+ifeq ($(FWD_LINKING_REQ),y)
+	LIBS := -L../src -lrdkafka $(LIBS) 
+endif
+
 LIBS += -lstdc++
 
 CHECK_FILES+= $(LIBFILENAME) $(LIBNAME).a
 
+
+file-check: lib
 check: file-check
 
 install: lib-install

=== src/Makefile ===
--- 
+++ 
@@ -20,6 +20,7 @@
 
 CHECK_FILES+= $(LIBFILENAME) $(LIBNAME).a
 
+file-check: lib
 check: file-check
 	@(printf "%-30s " "Symbol visibility" ; \
 	(($(SYMDUMPER) $(LIBFILENAME) | grep -q rd_kafka_new) && \

=== tests/Makefile ===
TESTSRCS ?= $(wildcard 0*-*.c) $(wildcard 0*-*.cpp)
TESTS    ?= $(TESTSRCS:%.cpp=%.test)
TESTS0    = $(TESTS:%.c=%.test)

%.test: ../src/librdkafka.a test.o %.c
	$(CC) $(CFLAGS) $^ -o $@ $(LDFLAGS) -lrdkafka $(LIBS)

%.test: ../src/librdkafka.a test.o %.cpp
	$(CXX) $(CFLAGS) $^ -o $@ $(LDFLAGS) -lrdkafka++ -lrdkafka $(LIBS)

all: $(TESTS0)
	for i in $^ ; do \
	 LD_LIBRARY_PATH=../src:../src-cpp ./run-test.sh $$i || exit 1 ; \
	done

include ../mklove/Makefile.base

CFLAGS += -I../src -I../src-cpp
LDFLAGS += -L../src -L../src-cpp

test.o: test.c
	$(CC) $(CFLAGS) -c $<


clean:
	rm -f *.test test.o

=== debian/changelog ===
librdkafka (0.8.6-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Use size_t instead of int for hexdump to fix FTBFS (Closes: 799993):
    assuming signed overflow does not occur when
    assuming that (X + c) >= X is always true  

 -- YunQiang Su <syq@debian.org>  Mon, 21 Dec 2015 21:20:59 +0800

librdkafka (0.8.6-1) unstable; urgency=medium

  * New upstream release.
  * Backport upstream commit f6fd0da, adding --disable-silent-rules
    compatibility support to mklove. (Closes: #788742)

 -- Faidon Liambotis <paravoid@debian.org>  Sun, 19 Jul 2015 01:36:18 +0300

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,6 @@
 Source: librdkafka
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Faidon Liambotis <paravoid@debian.org>
+Maintainer: Faidon Liambotis <paravoid@debian.org>
 Build-Depends: debhelper (>= 9), zlib1g-dev, perl
 Standards-Version: 3.9.6
 Section: libs

## librdkafka 0.9.1

=== src-cpp/Makefile ===
--- 
+++ 
@@ -3,8 +3,9 @@
 LIBVER=		1
 
 CXXSRCS=	RdKafka.cpp ConfImpl.cpp HandleImpl.cpp \
-		ConsumerImpl.cpp ProducerImpl.cpp \
-		TopicImpl.cpp MessageImpl.cpp
+		ConsumerImpl.cpp ProducerImpl.cpp KafkaConsumerImpl.cpp \
+		TopicImpl.cpp TopicPartitionImpl.cpp MessageImpl.cpp \
+		QueueImpl.cpp MetadataImpl.cpp
 
 HDRS=		rdkafkacpp.h
 
@@ -24,14 +25,14 @@
 ifeq ($(_UNAME_S),Darwin)
 	FWD_LINKING_REQ=y
 endif
-ifeq ($(shell uname -o),Cygwin)
+ifeq ($(_UNAME_S),AIX)
+	FWD_LINKING_REQ=y
+endif
+ifeq ($(shell uname -o 2>/dev/null),Cygwin)
 	FWD_LINKING_REQ=y
 endif
 
-ifeq ($(FWD_LINKING_REQ),y)
-	LIBS := -L../src -lrdkafka $(LIBS) 
-endif
-
+LIBS := -L../src -lrdkafka $(LIBS) 
 LIBS += -lstdc++
 
 CHECK_FILES+= $(LIBFILENAME) $(LIBNAME).a
@@ -50,7 +51,7 @@
 endif
 
 $(LIBNAME).lds: $(HDRS)
-	@(echo "$(MKL_YELLOW)Generating linker script $@ from $(HDRS)$(MKL_CLR_RESET)" ; \
-	  cat ../src/rdkafka.h | ../lds-gen.pl > $@)
+	@(printf "$(MKL_YELLOW)Generating linker script $@ from $(HDRS)$(MKL_CLR_RESET)\n" ; \
+	  cat ../src/rdkafka.h | ../lds-gen.py > $@)
 
 -include $(DEPS)

=== src/Makefile ===
PKGNAME=	librdkafka
LIBNAME=	librdkafka
LIBVER=		1

-include ../Makefile.config

SRCS_$(WITH_SASL) += rdkafka_sasl.c
SRCS_$(WITH_SNAPPY) += snappy.c
SRCS_$(WITH_ZLIB) += rdgz.c

SRCS=		rdkafka.c rdkafka_broker.c rdkafka_msg.c rdkafka_topic.c \
		rdkafka_conf.c rdkafka_timer.c rdkafka_offset.c \
		rdkafka_transport.c rdkafka_buf.c rdkafka_queue.c rdkafka_op.c \
		rdkafka_request.c rdkafka_cgrp.c rdkafka_pattern.c \
		rdkafka_partition.c rdkafka_subscription.c \
		rdkafka_assignor.c rdkafka_range_assignor.c \
		rdkafka_roundrobin_assignor.c rdkafka_feature.c \
		rdcrc32.c rdaddr.c rdrand.c rdlist.c tinycthread.c \
		rdlog.c rdstring.c \
		$(SRCS_y)

HDRS=		rdkafka.h

OBJS=		$(SRCS:.c=.o)


all: lib check

include ../mklove/Makefile.base

CHECK_FILES+= $(LIBFILENAME) $(LIBNAME).a

file-check: lib
check: file-check
	@(printf "%-30s " "Symbol visibility" ; \
		(($(SYMDUMPER) $(LIBFILENAME) | grep rd_kafka_new >/dev/null) && \
		($(SYMDUMPER) $(LIBFILENAME) | grep -v rd_kafka_destroy >/dev/null) && \
		printf "$(MKL_GREEN)OK$(MKL_CLR_RESET)\n") || \
		printf "$(MKL_RED)FAILED$(MKL_CLR_RESET)\n")

install: lib-install

clean: lib-clean

ifeq ($(WITH_LDS),y)
# Enable linker script if supported by platform
LIB_LDFLAGS+= $(LDFLAG_LINKERSCRIPT)$(LIBNAME).lds
endif

$(LIBNAME).lds: $(HDRS)
	@(printf "$(MKL_YELLOW)Generating linker script $@ from $(HDRS)$(MKL_CLR_RESET)\n" ; \
	  cat $(HDRS) | ../lds-gen.py > $@)

-include $(DEPS)

=== tests/Makefile ===
TESTSRCS_C = $(wildcard 0*-*.c)
TESTSRCS_CXX= $(wildcard 0*-*.cpp)
OBJS	  = $(TESTSRCS_C:%.c=%.o) $(TESTSRCS_CXX:%.cpp=%.o)

BIN	  = merged
LIBS	 += -lrdkafka
OBJS	 += test.o tinycthread.o
CFLAGS += -I../src
CXXFLAGS += -I../src -I../src-cpp
LDFLAGS += -L../src -L../src-cpp


-include ../Makefile.config

all: $(BIN) run_par

trunk: build
	./broker_version_tests.py trunk
	./sasl_test.py trunk

# Run the full test suite(s)
full: build
	./broker_version_tests.py
	./sasl_test.py

run_par: $(BIN)
	@echo "Running tests in parallel"
	./run-test.sh -p5 ./$(BIN)

run_seq: $(BIN)
	@echo "Running tests sequentially"
	./run-test.sh -p1 ./$(BIN)

run_local: $(BIN)
	@echo "Running local broker-less tests"
	./run-test.sh -p5 -l ./$(BIN)

build: $(BIN)

test.o: ../src/librdkafka.a


include ../mklove/Makefile.base

tinycthread.o: ../src/tinycthread.c
	$(CC) $(CPPFLAGS) $(CFLAGS) -c $<


clean:
	rm -f *.test $(OBJS) $(BIN)


clean-output:
	# Clean test output files
	rm -f stats_*.json *.offset

realclean: clean clean-output
	rm -f test_report_*.json

=== debian/changelog ===
librdkafka (0.9.1-1) unstable; urgency=medium

  * New upstream release (Closes: #816047).
    - Remove 0001-mklove-update-add-disable-silent-rules patch (not needed)
    - Remove 0002_hexdump_use_size_t_instead_of_int patch (not needed)
    - Fixes a GCC6-identified warning and possible FTBFS. (Closes: #811596)
  * Add Build-Depends to libssl-dev/libsasl2-dev, to enable Kafka 0.9
    encryption and authentication.
  * Update the long description to mention 0.9 protocol support and also the
    high-performance aspect, by copying upstream's description almost
    verbatim.
  * Bump Standards-Version to 3.9.8 (no changes needed).
  * Switch Vcs-Git to GitHub's https (from git://)
  * Migrate from our own -dbg package to the automatic -dbgsym package.
  * Update librdkafka1.symbols with 0.9.0' and 0.9.1's new symbols.
  * Ship the new C++ library, by shipping a new binary package, librdkafka++1.
  * Ship pkg-config files in the -dev package for both the C and C++
    libraries.
  * Replace the perl build-dependency by python, as the build system (among
    others) now requires it.

 -- Faidon Liambotis <paravoid@debian.org>  Mon, 30 May 2016 16:07:33 +0300

=== debian/control ===
Source: librdkafka
Priority: optional
Maintainer: Faidon Liambotis <paravoid@debian.org>
Build-Depends: debhelper (>= 9), zlib1g-dev, libssl-dev, libsasl2-dev, python
Standards-Version: 3.9.8
Section: libs
Homepage: https://github.com/edenhill/librdkafka
Vcs-Git: https://github.com/edenhill/librdkafka.git -b debian
Vcs-Browser: https://github.com/edenhill/librdkafka/tree/debian

Package: librdkafka1
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: library implementing the Apache Kafka protocol
 librdkafka is a C library implementation of the Apache Kafka protocol,
 containing both Producer and Consumer support. It was designed with message
 delivery reliability and high performance in mind, current figures exceed
 800000 msgs/second for the producer and 3 million msgs/second for the
 consumer. It implements both the 0.8 and 0.9 versions of the protocol.
 .
 More information about Apache Kafka can be found at http://kafka.apache.org/
 .
 This package contains the C shared library.

Package: librdkafka++1
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: library implementing the Apache Kafka protocol (C++ bindings)
 librdkafka is a C library implementation of the Apache Kafka protocol,
 containing both Producer and Consumer support. It was designed with message
 delivery reliability and high performance in mind, current figures exceed
 800000 msgs/second for the producer and 3 million msgs/second for the
 consumer. It implements both the 0.8 and 0.9 versions of the protocol.
 .
 More information about Apache Kafka can be found at http://kafka.apache.org/
 .
 This package contains the C++ shared library.

Package: librdkafka-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: librdkafka1 (= ${binary:Version}), librdkafka++1 (= ${binary:Version}), ${misc:Depends}
Description: library implementing the Apache Kafka protocol (development headers)
 librdkafka is a C library implementation of the Apache Kafka protocol,
 containing both Producer and Consumer support. It was designed with message
 delivery reliability and high performance in mind, current figures exceed
 800000 msgs/second for the producer and 3 million msgs/second for the
 consumer. It implements both the 0.8 and 0.9 versions of the protocol.
 .
 More information about Apache Kafka can be found at http://kafka.apache.org/
 .
 This package contains the development headers.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

override_dh_strip:
	dh_strip -O--dbgsym-migration='librdkafka1-dbg (<< 0.9.1-1~)'

## librdkafka 0.9.3

=== Makefile ===
LIBSUBDIRS=	src src-cpp

CHECK_FILES+=	CONFIGURATION.md \
		examples/rdkafka_example examples/rdkafka_performance \
		examples/rdkafka_example_cpp

PACKAGE_NAME?=	librdkafka
VERSION?=	$(shell python packaging/get_version.py src/rdkafka.h)

# Jenkins CI integration
BUILD_NUMBER ?= 1

.PHONY:

all: mklove-check libs CONFIGURATION.md check

include mklove/Makefile.base

libs:
	@(for d in $(LIBSUBDIRS); do $(MAKE) -C $$d || exit $?; done)

CONFIGURATION.md: src/rdkafka.h examples
	@printf "$(MKL_YELLOW)Updating$(MKL_CLR_RESET)\n"
	@echo '//@file' > CONFIGURATION.md.tmp
	@(examples/rdkafka_performance -X list >> CONFIGURATION.md.tmp; \
		cmp CONFIGURATION.md CONFIGURATION.md.tmp || \
		mv CONFIGURATION.md.tmp CONFIGURATION.md; \
		rm -f CONFIGURATION.md.tmp)

file-check: CONFIGURATION.md examples
check: file-check
	@(for d in $(LIBSUBDIRS); do $(MAKE) -C $$d $@ || exit $?; done)

install:
	@(for d in $(LIBSUBDIRS); do $(MAKE) -C $$d $@ || exit $?; done)

examples tests: .PHONY libs
	$(MAKE) -C $@

docs:
	doxygen Doxyfile
	@echo "Documentation generated in staging-docs"

clean-docs:
	rm -rf staging-docs

clean:
	@$(MAKE) -C tests $@
	@$(MAKE) -C examples $@
	@(for d in $(LIBSUBDIRS); do $(MAKE) -C $$d $@ ; done)

distclean: clean
	./configure --clean
	rm -f config.log config.log.old

archive:
	git archive --prefix=$(PACKAGE_NAME)-$(VERSION)/ \
		-o $(PACKAGE_NAME)-$(VERSION).tar.gz HEAD
	git archive --prefix=$(PACKAGE_NAME)-$(VERSION)/ \
		-o $(PACKAGE_NAME)-$(VERSION).zip HEAD

rpm: distclean
	$(MAKE) -C packaging/rpm

=== examples/Makefile ===
--- 
+++ 
@@ -1,4 +1,6 @@
-EXAMPLES ?= rdkafka_example rdkafka_performance rdkafka_example_cpp
+EXAMPLES ?= rdkafka_example rdkafka_performance rdkafka_example_cpp \
+	rdkafka_consumer_example rdkafka_consumer_example_cpp \
+	kafkatest_verifiable_client
 
 all: $(EXAMPLES)
 
@@ -17,14 +19,25 @@
 	@echo "# $@ is ready"
 	@echo "#"
 	@echo "# Run producer (write messages on stdin)"
-	@echo "./rdkafka_example -P -t <topic> -p <partition>"
+	@echo "./$@ -P -t <topic> -p <partition>"
 	@echo ""
 	@echo "# or consumer"
-	@echo "./rdkafka_example -C -t <topic> -p <partition>"
+	@echo "./$@ -C -t <topic> -p <partition>"
 	@echo ""
 	@echo "#"
 	@echo "# More usage options:"
-	@echo "./rdkafka_example --help"
+	@echo "./$@ -h"
+
+rdkafka_consumer_example: ../src/librdkafka.a rdkafka_consumer_example.c
+	$(CC) $(CPPFLAGS) $(CFLAGS) rdkafka_consumer_example.c -o $@ $(LDFLAGS) \
+		../src/librdkafka.a $(LIBS)
+	@echo "# $@ is ready"
+	@echo "#"
+	@echo "./$@ <topic[:part]> <topic2[:part]> .."
+	@echo ""
+	@echo "#"
+	@echo "# More usage options:"
+	@echo "./$@ -h"
 
 rdkafka_performance: ../src/librdkafka.a rdkafka_performance.c
 	$(CC) $(CPPFLAGS) $(CFLAGS) rdkafka_performance.c -o $@ $(LDFLAGS) \
@@ -39,11 +52,20 @@
 	@echo ""
 	@echo "#"
 	@echo "# More usage options:"
-	@echo "./$@ --help"
+	@echo "./$@ -h"
 
 
 rdkafka_example_cpp: ../src-cpp/librdkafka++.a ../src/librdkafka.a rdkafka_example.cpp
 	$(CXX) $(CPPFLAGS) $(CXXFLAGS) rdkafka_example.cpp -o $@ $(LDFLAGS) \
+		../src-cpp/librdkafka++.a ../src/librdkafka.a $(LIBS) -lstdc++
+
+kafkatest_verifiable_client: ../src-cpp/librdkafka++.a ../src/librdkafka.a kafkatest_verifiable_client.cpp
+	$(CXX) $(CPPFLAGS) $(CXXFLAGS) kafkatest_verifiable_client.cpp -o $@ $(LDFLAGS) \
+		../src-cpp/librdkafka++.a ../src/librdkafka.a $(LIBS) -lstdc++
+
+
+rdkafka_consumer_example_cpp: ../src-cpp/librdkafka++.a ../src/librdkafka.a rdkafka_consumer_example.cpp
+	$(CXX) $(CPPFLAGS) $(CXXFLAGS) rdkafka_consumer_example.cpp -o $@ $(LDFLAGS) \
 		../src-cpp/librdkafka++.a ../src/librdkafka.a $(LIBS) -lstdc++
 
 rdkafka_zookeeper_example: ../src/librdkafka.a rdkafka_zookeeper_example.c
@@ -52,14 +74,14 @@
 	@echo "# $@ is ready"
 	@echo "#"
 	@echo "# Run producer (write messages on stdin)"
-	@echo "./rdkafka_zookeeper_example -P -t <topic> -p <partition>"
+	@echo "./$@ -P -t <topic> -p <partition>"
 	@echo ""
 	@echo "# or consumer"
-	@echo "./rdkafka_zookeeper_example -C -t <topic> -p <partition>"
+	@echo "./$@ -C -t <topic> -p <partition>"
 	@echo ""
 	@echo "#"
 	@echo "# More usage options:"
-	@echo "./rdkafka_zookeeper_example --help"
+	@echo "./$@ -h"
 
 clean:
 	rm -f $(EXAMPLES)

=== src/Makefile ===
--- 
+++ 
@@ -4,9 +4,19 @@
 
 -include ../Makefile.config
 
+ifneq ($(wildcard ../.git),)
+# Add librdkafka version string from git tag if this is a git checkout
+CPPFLAGS += -DLIBRDKAFKA_GIT_VERSION="\"$(shell git describe --abbrev=6 --dirty --tags 2>/dev/null)\""
+endif
+
 SRCS_$(WITH_SASL) += rdkafka_sasl.c
 SRCS_$(WITH_SNAPPY) += snappy.c
 SRCS_$(WITH_ZLIB) += rdgz.c
+SRCS_$(WITH_LZ4) += xxhash.c
+
+ifeq ($(HAVE_REGEX), n)
+SRCS_y += regexp.c
+endif
 
 SRCS=		rdkafka.c rdkafka_broker.c rdkafka_msg.c rdkafka_topic.c \
 		rdkafka_conf.c rdkafka_timer.c rdkafka_offset.c \
@@ -16,7 +26,8 @@
 		rdkafka_assignor.c rdkafka_range_assignor.c \
 		rdkafka_roundrobin_assignor.c rdkafka_feature.c \
 		rdcrc32.c rdaddr.c rdrand.c rdlist.c tinycthread.c \
-		rdlog.c rdstring.c \
+		rdlog.c rdstring.c rdkafka_event.c rdkafka_metadata.c \
+		rdregex.c \
 		$(SRCS_y)
 
 HDRS=		rdkafka.h

=== tests/Makefile ===
--- 
+++ 
@@ -4,7 +4,7 @@
 
 BIN	  = merged
 LIBS	 += -lrdkafka
-OBJS	 += test.o tinycthread.o
+OBJS	 += test.o tinycthread.o rdlist.o sockem.o
 CFLAGS += -I../src
 CXXFLAGS += -I../src -I../src-cpp
 LDFLAGS += -L../src -L../src-cpp
@@ -45,6 +45,9 @@
 tinycthread.o: ../src/tinycthread.c
 	$(CC) $(CPPFLAGS) $(CFLAGS) -c $<
 
+rdlist.o: ../src/rdlist.c
+	$(CC) $(CPPFLAGS) $(CFLAGS) -c $<
+
 
 clean:
 	rm -f *.test $(OBJS) $(BIN)
@@ -56,3 +59,6 @@
 
 realclean: clean clean-output
 	rm -f test_report_*.json
+
+00%:
+	TESTS=$@ ./run-test.sh ./$(BIN)

=== packaging/rpm/Makefile ===
PACKAGE_NAME?=	librdkafka
VERSION?=	$(shell ../get_version.py ../../src/rdkafka.h)

# Jenkins CI integration
BUILD_NUMBER?= 1

MOCK_CONFIG?=default

RESULT_DIR?=pkgs-$(VERSION)-$(BUILD_NUMBER)-$(MOCK_CONFIG)

all: rpm


SOURCES:
	mkdir -p SOURCES

archive: SOURCES
	cd ../../ && \
	git archive --prefix=$(PACKAGE_NAME)-$(VERSION)/ \
		-o packaging/rpm/SOURCES/$(PACKAGE_NAME)-$(VERSION).tar.gz HEAD


build_prepare: archive
	mkdir -p $(RESULT_DIR)
	rm -f $(RESULT_DIR)/$(PACKAGE_NAME)*.rpm


srpm: build_prepare
	/usr/bin/mock \
		-r $(MOCK_CONFIG) \
		--define "__version $(VERSION)" \
		--define "__release $(BUILD_NUMBER)" \
		--resultdir=$(RESULT_DIR) \
		--buildsrpm \
		--spec=librdkafka.spec \
		--sources=SOURCES
	@echo "======= Source RPM now available in $(RESULT_DIR) ======="

rpm: srpm
	/usr/bin/mock \
		-r $(MOCK_CONFIG) \
		--define "__version $(VERSION)"\
		--define "__release $(BUILD_NUMBER)"\
		--resultdir=$(RESULT_DIR) \
		--rebuild $(RESULT_DIR)/$(PACKAGE_NAME)*.src.rpm
	@echo "======= Binary RPMs now available in $(RESULT_DIR) ======="

clean:
	rm -rf SOURCES

distclean: clean
	rm -f build.log root.log state.log available_pkgs installed_pkgs \
		*.rpm *.tar.gz

=== debian/changelog ===
librdkafka (0.9.3-1~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Christos Trochalakis <ctrochalakis@debian.org>  Tue, 07 Feb 2017 10:31:04 +0200

librdkafka (0.9.3-1) unstable; urgency=medium

  * New upstream release.
  * Add Build-Depends to liblz4-dev to enable LZ4 compression.
  * Add copyright for xxhash.[hc] and regexp.[hc].
  * Update librdkafka1.symbols for 0.9.2 and 0.9.3.
  * Use hardening build flags.
  * Add myself to Uploaders.
  * Switch to debhelper 10.
  * Move packaging to alioth, under the pkg-kafka team.

 -- Christos Trochalakis <ctrochalakis@debian.org>  Tue, 24 Jan 2017 17:33:40 +0200
